/**
 * Title:	    Graph
 * Copyright:	Copyright (c) Jan-Pascal van Best
 * Email:	    janpascal@vanbest.org
 * @author	    Jan-Pascal van Best
 **************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package nl.tudelft.tbm.graph;


import java.util.*;
import java.util.logging.*;
import java.io.*;
import java.lang.*;

import org.xml.sax.*;

import nl.tudelft.tbm.graph.*;


public class Edge extends Pair implements Attributed, Cloneable { //, XMLSerializable {
    private static Logger logger = Logger.getLogger("nl.tudelft.tbm.graph");
    boolean bidir = false;

    public Edge(Object x, Object y) {
        super(x, y);
    }

    public void setBidir(boolean bidir) {
        this.bidir = bidir;
    }

    public boolean getBidir() {
        return bidir;
    }

    protected Object clone() throws CloneNotSupportedException {
        return super.clone();
    }

    public void merge(Edge e) {
        if (x==e.y && y==e.x) {
            bidir = true;
        }
    }
    
    public String getName() {
        return "";
    }

    public String getLabel() {
        if (bidir) {
            return x.toString() + "<>" + y.toString();
        } else {
            return x.toString() + "->" + y.toString();
        }
    }

    public List getPropertyNames() {
        String[] strings = {"bidir"};
        List result = new ArrayList();
        result.addAll(Arrays.asList(strings));
        return result;
    }

    public String getProperty(String name) {
        String result;

        if (name.equals("bidir")) {
            result = "" + bidir;
        } else
            result = null;
        return result;
    }

    /*
     static String getElementName() {return "edge";};

     public void writeXML(PrintWriter out, String indent) throws IOException{
     String from = (x instanceof Attributed) ? ((Attributed)x).getName() : x.toString();
     String to = (y instanceof Attributed) ? ((Attributed)y).getName() : y.toString();
     from = from.replace('&','+'); // XML does not like ampersands
     to = to.replace('&','+');
     out.println(indent+"<edge source=\""+from+"\" target=\""+to+"\">");
     //	  out.println(indent+"	  <style>");
     //	  out.println(indent+"	      <line colour=\"black\" linewidth=\"1.0\"/>");
     //	  out.println(indent+"	  </style>");
     out.println(indent+"</edge>");
     }

     public static XMLSerializable createObject(Attributes attributes, String contents, List subElements) throws Exception {
     logger.info("Creating new Edge from XML");
     String xName = attributes.getValue("source");
     String yName = attributes.getValue("target");
     logger.info("	Names: "+xName+"->"+yName);
     Object x = XMLSerializer.getObject(xName);
     Object y = XMLSerializer.getObject(yName);
     logger.info("	Creating edge: "+x.toString()+"->"+y.toString());
     return new Edge(x, y);
     }
     */
    public String toString() {
        return getLabel();
    }
}

