// This progarm is intended to query and display  from remote MySql database server
// that holds the TTM database file.

package nl.tudelft.tbm.graph;


import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.text.*;
import java.util.*;
import nl.tudelft.tbm.graph.*;
import java.util.logging.*;


public class NodeComponent extends JPanel {
    private static Logger logger = Logger.getLogger("nl.tudelft.tbm.graph");
    public final static int SHOW_LABEL_NONE = 0;
    public final static int SHOW_LABEL_LABEL = 1;
    public final static int SHOW_LABEL_NAME = 2;

    Dimension minSize;
    Node node;
    int size;
    Ellipse2D shape = null;
    int showLabel = SHOW_LABEL_NONE;
    String labelString = "";
    Color color = Color.BLACK;

    public NodeComponent(Node node, int size) {
        this.node = node;
        this.size = size;
        minSize = new Dimension(size, size);
        setOpaque(false);
        //	  addMouseListener(this);
        setSize(minSize);
        //	  addMouseMotionListener(this);
        setToolTipText(node.getLabel() + " (" + node.getName() + ")");
    }

    public void setShowLabel(int showLabel) {
        this.showLabel = showLabel;
        if (showLabel != SHOW_LABEL_NONE) {
            Graphics2D g2 = (Graphics2D) getGraphics();

            if (g2 != null) {
                labelString = node.getLabel();
                switch (showLabel) {
                case SHOW_LABEL_LABEL:
                    labelString = node.getLabel();
                    break;

                case SHOW_LABEL_NAME:
                    labelString = node.getName();
                    break;
                }
                FontMetrics fm = g2.getFontMetrics();
                Rectangle2D.Float sb = (Rectangle2D.Float) fm.getStringBounds(labelString, g2);

                setSize(size + (int) sb.getWidth(), Math.max(size, (int) sb.getHeight()));
            } else
                setSize(minSize);
        } else {
            setSize(minSize);
        }
        repaint();
    }

    public void setColor(Color c) {
        this.color = c;
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);

        Graphics2D g2 = (Graphics2D) g;

        //	  g2.fill(new Ellipse2D.Double(0,0,NODE_SIZE,NODE_SIZE));
        //	  int x = (int) (node.getX()-NODE_SIZE/2);
        //	  int y = (int) (node.getY()-NODE_SIZE/2);
        //	  logger.info("Painting at "+x+","+y);
        //	  g.fillOval(x,y,NODE_SIZE, NODE_SIZE);
        shape = new Ellipse2D.Double(0, 0, size, size);
        g2.setPaint(color);
        g2.fill(shape);
        if (showLabel != SHOW_LABEL_NONE) {
            g2.setPaint(Color.BLUE);
            g2.drawString(labelString, size, getHeight() - 1);
        }
        //	  g.fillOval(0,0,NODE_SIZE, NODE_SIZE);
        //	  g2.fill(new Ellipse2D.Double(x,y,NODE_SIZE,NODE_SIZE));
        //	  setLocation((int) getX()-NODE_SIZE/2, (int)getY()-NODE_SIZE/2);
    }

    /*
     public Rectangle getBounds(Rectangle rv) {
     rv.x = (int)(node.getX()-NODE_SIZE/2);
     rv.y = (int)(node.getY()-NODE_SIZE/2);
     rv.width = NODE_SIZE;
     rv.height = NODE_SIZE;
     return rv;
     }

     public Rectangle getBounds() {
     Rectangle rv = new Rectangle();
     rv.x = (int)(node.getX()-NODE_SIZE/2);
     rv.y = (int)(node.getY()-NODE_SIZE/2);
     rv.width = NODE_SIZE;
     rv.height = NODE_SIZE;
     return rv;
     }
     */

    public Dimension getMinimumSize() {
        //	  logger.info("Entering NodeComponent.getMinimumSize()");
        return minSize;
    }

    public Dimension getPreferredSize() {
        //	  logger.info("Entering NodeComponent.getPreferredSize()");
        return minSize;
    }

    public void doLayout() {
        //	  logger.info("Entering NodeComponent.doLayout()");
        if (showLabel != SHOW_LABEL_NONE) {
            Graphics2D g2 = (Graphics2D) getGraphics();
            FontMetrics fm = g2.getFontMetrics();
            Rectangle2D.Float sb = (Rectangle2D.Float) fm.getStringBounds(labelString, g2);

            setSize(size + (int) sb.getWidth(), Math.max(size, (int) sb.getHeight()));
        } else {
            setSize(minSize);
        }
    }

    public boolean contains(Point p) {
        return contains(p.x, p.y);
    }

    public boolean contains(int x, int y) {
        return shape != null && shape.contains(x, y);
    }

}

