/**
 * Title:	Traces
 * Description: An analysis tool for traceroutes
 * Copyright:	Copyright (c) Jan-Pascal van Best
 * Email:	    janb@tbm.tudelft.nl
 * @author	    Jan-Pascal van Best
 **************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package nl.tudelft.tbm.graph;


import java.io.*;
import java.lang.*;
import java.lang.reflect.*;
import java.text.*;
import java.util.*;

import java.awt.Frame;

// import org.xml.sax.*;

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;


public class Test {

    public Test() {
        super();
    }

    static void test1() throws Exception {
        //	  XMLSerializer x = new XMLSerializer();
        /*
         XMLSerializer.register(NodeImpl.getElementName(), Class.forName("nl.tudelft.tbm.graph.NodeImpl"));
         XMLSerializer.register(Edge.getElementName(), Class.forName("nl.tudelft.tbm.graph.Edge"));
         XMLSerializer.register(Graph.getElementName(), Class.forName("nl.tudelft.tbm.graph.Graph"));

         NodeImpl n = new NodeImpl("test1");

         Graph graph = new Graph();

        //	  XMLSerializer.write(n, "c:\\temp\\test1.xml");
        //	  Node n2 = (Node) XMLSerializer.read("c:\\temp\\test1.xml");
        //	  XMLSerializer.write(n, "c:\\temp\\test2.xml");

        Node A = new NodeImpl("A");
        Node B = new NodeImpl("B");
        Edge e1 = new Edge(A, B);

        graph.addEdge(e1);
        XMLSerializer.write(graph, "c:\\temp\\test1.xml");
        Graph g2 = (Graph) XMLSerializer.read("c:\\temp\\test1.xml");
        System.out.println("Read graph: "+g2.toString());
        XMLSerializer.write(g2, "c:\\temp\\test2.xml");

        //	  XMLSerializer.write(e1, "c:\\temp\\test3.xml");
        //	  Edge e2 = (Edge) XMLSerializer.read("c:\\temp\\test3.xml");
        //	  System.out.println("Read edge: "+e2.toString());
        //	  XMLSerializer.write(e2, "c:\\temp\\test4.xml");
        */
    }

    static void test2() throws Exception {

        /*
         Frame f = new Frame("Testing GraphComponent");
         Graph graph = new Graph();
         GraphComponent c = new GraphComponent(graph);
         c.setShowLabels(true);
         f.add(c);
         f.setSize(600,500);
         f.show();
         */
    }

    static void test3() throws Exception {
        SAXBuilder builder = new SAXBuilder();
        Document doc = builder.build("e:\\temp\\test-3days-5to9-IP.xml");
        XMLOutputter fmt = new XMLOutputter();

        Element root = doc.getRootElement(); // This is a GraphXML

        Element XMLgraph = root.getChild("graph");
        Graph graph = new Graph();

        List XMLnodes = XMLgraph.getChildren("node");

        for (Iterator i = XMLnodes.iterator(); i.hasNext();) {
            Element XMLnode = (Element) i.next();
            Node node = createNode(XMLnode);
        }

        //	  fmt.output(doc, System.out);
    }

    public static Node createNode(Element xml) {
        String name = xml.getAttributeValue("name");
        Element XMLLabel = xml.getChild("label");
        String label = null;

        if (XMLLabel != null) label = XMLLabel.getTextNormalize();
        List XMLproperties = xml.getChildren("property");
        boolean isTestBox = false;

        for (Iterator i = XMLproperties.iterator(); i.hasNext();) {
            Element XMLprop = (Element) i.next();
            String propName = XMLprop.getAttributeValue("name");
            String propValue = XMLprop.getAttributeValue("content");

            if (propName.equals("dates")) {
            } else if (propName.equals("IPaddress")) {
            } else if (propName.equals("hostname")) {
            } else if (propName.equals("ASnumber")) {
            } else if (propName.equals("ASname")) {
            } else if (propName.equals("testboxnumber")) {
                System.out.println("Testbox: " + propValue);
            } else if (propName.equals("latitude")) {
            } else if (propName.equals("longitude")) {
            } else if (propName.equals("description")) {
            }
        }
        return new AbstractNode();
    }

    static void test4() {
        AnnealLayout.test();
    }

    static void test5() {
        Graph graph = new Graph();

        Node n1 = new AbstractNode("A", "A"); n1.setPosition(100, 100);
        Node n2 = new AbstractNode("B", "B"); n2.setPosition(200, 100);
        Node n3 = new AbstractNode("C", "C"); n3.setPosition(200, 200);

        graph.addEdge(new Edge(n1, n2));
        graph.addEdge(new Edge(n2, n3));
        graph.addEdge(new Edge(n2, n1));

        System.out.println(graph.toString());

        Frame f = new Frame("Testing GraphComponent");
        GraphComponent c = new GraphComponent(graph);

        f.add(c);
        f.setSize(600, 500);
        f.show();
        c.setShowLabels(NodeComponent.SHOW_LABEL_NAME);
        c.setZoomFixed(true);

        AnnealLayout layout1 = new AnnealLayout(graph, c);
        PartialLayout layout2 = new PartialLayout(graph, c, layout1, 0.85, PartialLayout.GET_LOW_DEGREE_NODES, true);

//        layout2.doLayout();
    }

    public void run(String[] args) {
        //	  Log.showLog();
        String arg1 = "";

        try {
            if (args.length >= 2) arg1 = args[1];
            String test = args[0];
            int num;

            if (test == null) num = 15;
            else {
                if (test.equals("root")) num = 15;
                else if (test.equals("cache")) num = 13;
                else {
                    try {
                        num = Integer.parseInt(test);
                    } catch (NumberFormatException e) {
                        num = 2;
                    }
                }
            }
            System.out.println("Doing test #" + num);
            Method method = this.getClass().getDeclaredMethod("test"+num, null);
            method.invoke(this, null);
            System.in.read();
        } catch (Throwable t) {
            t.printStackTrace();
        }
        //	  Log.log("Finished; close log window to exit");
        //	  while(Log.log.isVisible()){}
    }

    public static void main(String[] args) {
        Test test = new Test();
        test.run(args);
        System.exit(0);
    }
}

/*
 class NodeImpl extends AbstractNode implements XMLSerializable {
 NodeImpl(String name) {
 super();
 this.name=name;
 this.label=name;
 }
 static String getElementName() {return "nodeimpl";};
 public void writeXML(PrintWriter out, String indent) throws IOException{
 out.println(indent+"<nodeimpl name=\""+getName()+"\"/>");
 }
 public static XMLSerializable createObject(Attributes attributes, String contents, List subElements) throws Exception {
 return new NodeImpl(attributes.getValue("name"));
 }

 public String toString() { return "NodeImpl:"+name; }
 }

 */
